/*
   Kickshaw - A Menu Editor for Openbox

   Copyright (c) 2010–2021        Marcus Schätzle

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along 
   with Kickshaw. If not, see http://www.gnu.org/licenses/.
*/

#ifndef __adding_and_deleting_h
#define __adding_and_deleting_h

extern ks_data ks;

extern void activate_change_done (void);
extern void check_for_existing_options (GtkTreeIter *parent, const guint8 number_of_opts, 
                                        const gchar **options_array, gboolean *opts_exist);
extern guint8 check_if_invisible_ancestor_exists (GtkTreeModel *local_model, GtkTreePath *local_path);
extern GtkWidget *create_dialog (GtkWidget **dialog, const gchar *dialog_title, const gchar *icon_name, const gchar *label_txt, 
                                 const gchar *button_txt_1, const gchar *button_txt_2, const gchar *button_txt_3, 
                                 const gboolean use_header_bar, const gboolean show_immediately);
extern void expand_row_from_iter (GtkTreeIter *local_iter);
extern gchar *extract_substring_via_regex (const gchar *string, const gchar *regex_str);
extern gchar *get_modification_time_for_icon (const gchar *icon_path);
extern void push_new_item_on_undo_stack (const gboolean after_save);
extern void repopulate_txt_fields_array (void);
extern gboolean regex_match_simple (const gchar *regex_str, const gchar *string, const guint32 compile_options, const guint32 match_options);
extern void row_selected (void);
extern gboolean set_icon (GtkTreeIter *icon_iter, const gchar *icon_path, const gboolean display_err_msg, const gboolean during_undo_redo);
extern void show_errmsg (const gchar *errmsg_raw_txt);
extern void show_or_hide_find_grid (void);
extern void sort_execute_or_startupnotify_options_after_insertion (GtkTreeSelection *selection, GtkTreeIter *parent, 
                                                                   const gchar *execute_or_startupnotify, const gchar *option);
extern gboolean streq_any (const gchar *string, ...) G_GNUC_NULL_TERMINATED;
extern void visually_indicate_request_for_user_intervention (GtkWidget *widget, GtkCssProvider *css_provider);

#endif
