/*
   Kickshaw - A Menu Editor for Openbox

   Copyright (c) 2010–2021        Marcus Schätzle

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along 
   with Kickshaw. If not, see http://www.gnu.org/licenses/.
*/

#ifndef __load_menu_h
#define __load_menu_h

extern ks_data ks;

extern gboolean add_icon_occurrence_to_list (G_GNUC_UNUSED GtkTreeModel *foreach_model, 
                                                           GtkTreePath  *foreach_path,
                                                           GtkTreeIter  *foreach_iter,
                                             G_GNUC_UNUSED gpointer      user_data);
extern void change_view_and_options_GMenu (GSimpleAction *simple_action, GVariant *parameter, gpointer key_str_pointer);
extern gboolean check_for_external_file_and_settings_changes (G_GNUC_UNUSED gpointer identifier);
extern guint8 check_if_invisible_ancestor_exists (GtkTreeModel *local_model, GtkTreePath *local_path);
extern gchar *choose_icon (void);
extern void clear_global_data (void);
extern gboolean continue_despite_unsaved_changes (void);
extern GtkWidget *create_dialog (GtkWidget **dialog, const gchar *dialog_title, const gchar *icon_name, const gchar *label_txt, 
                                 const gchar *button_txt_1, const gchar *button_txt_2, const gchar *button_txt_3, 
                                 const gboolean use_header_bar, const gboolean show_immediately);
extern void create_file_dialog (GtkWidget **dialog, const gboolean open);
extern gchar *extract_substring_via_regex (const gchar *string, const gchar *regex_str);
void free_elements_of_static_string_array (gchar **string_array, gint8 number_of_fields, const gboolean set_to_NULL);
extern gchar *get_modification_time_for_icon (const gchar *icon_path);
extern GtkWidget *new_label_with_formattings (const gchar *label_txt, const gboolean wrap);
extern void push_new_item_on_undo_stack (const gboolean after_save);
extern gboolean regex_match_simple (const gchar *regex_str, const gchar *string, const guint32 compile_options, const guint32 match_options);
extern void remove_rows (const gchar *origin);
extern void row_selected (void);
extern void set_filename_and_window_title (gchar *new_filename);
extern void set_header_bar_for_dialog (GtkWidget *dialog, const gchar *dialog_title_txt);
extern void show_errmsg (const gchar *errmsg_raw_txt);
extern void show_message_dialog (const gchar *dialog_title, const gchar *icon_name, const gchar *label_txt, const gchar *button_txt);
extern gboolean sort_loop_after_sorting_activation (GtkTreeModel *foreach_model, GtkTreePath *foreach_path,
                                                    GtkTreeIter *foreach_iter, G_GNUC_UNUSED gpointer user_data);
extern gboolean streq_any (const gchar *string, ...) G_GNUC_NULL_TERMINATED;

#endif
